﻿package  {
	
	import flash.display.MovieClip;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.getDefinitionByName;
	
	import flare.basic.*;
	import flare.core.*;
	import flare.system.*;
	import flare.utils.*;
	import flare.loaders.*;
	
	
	public class Main extends MovieClip {
		
		[Embed(source="car.zf3d", mimeType="application/octet-stream")]
		private var car_model:Class;
		
		[Embed(source="road.zf3d", mimeType="application/octet-stream")]
		private var road_model:Class;
		
		private var scene:Scene3D;
		private var car_loader:Flare3DLoader;
		private var road_loader:Flare3DLoader;
		
		private var total_model:Number = 2;
		
		private var car_speed:Number = 0;
		private var car_rot:Number = 0;
		private var wheel_rot:Number = 0;
		private var wheel_spin:Number = 0;
		private var car_length:Number = 50;
		
		private var cam_dist:Number = 50;
		private var cam_height:Number = 40;
		
		private var to_rad:Number = Math.PI/180;
		
		private var wheel1:Pivot3D;
		private var wheel2:Pivot3D;
		private var wheel3:Pivot3D;
		private var wheel4:Pivot3D;
		
		public function Main() {
			// constructor code
			scene = new Scene3D(this);
			scene.camera = new Camera3D("myCamera");
			scene.camera.setPosition(0, 50, 50);
			scene.camera.lookAt(0,0,0);
			
			add_car();
			add_road();
			scene.pause();
		}
		
		private function add_car():void{
			car_loader = new Flare3DLoader(new car_model, null, scene);
			car_loader.addEventListener(Event.COMPLETE, load_assets);
			car_loader.load();
			car_loader.parent = scene;
		}
		
		private function add_road():void{
			road_loader = new Flare3DLoader(new road_model, null, scene);
			road_loader.addEventListener(Event.COMPLETE, load_assets);
			road_loader.load();
			road_loader.parent = scene;
		}
		
		private function load_assets(e:Event):void{
			total_model--;
			if (total_model == 0){
				wheel1 = car_loader.getChildByName("wheel01");
				wheel2 = car_loader.getChildByName("wheel02");
				wheel3 = car_loader.getChildByName("wheel03");
				wheel4 = car_loader.getChildByName("wheel04");
				scene.resume();
				scene.addEventListener(Scene3D.UPDATE_EVENT, updateEvent);
			}
		}
		
		private function move_wheel():void{
			wheel_spin+=car_speed*5;
			wheel1.setRotation(wheel_spin, wheel_rot+90, 0);
			wheel2.setRotation(wheel_spin, wheel_rot+90, 0);
			wheel3.setRotation(wheel_spin, 90, 0);
			wheel4.setRotation(wheel_spin, 90, 0);
		}
		
		private function updateEvent(e:Event):void{
			if (Input3D.keyDown(Input3D.UP)){
				if (car_speed < 5) car_speed+=0.25;
			}else if (Input3D.keyDown(Input3D.DOWN)){
				if (car_speed > -5) car_speed-=0.25;
			}else{
				car_speed*=0.95;
			}
			
			if (Input3D.keyDown(Input3D.RIGHT)){
				if (wheel_rot < 40) wheel_rot+=2;
			}else if (Input3D.keyDown(Input3D.LEFT)){
				if (wheel_rot > -40) wheel_rot-=2;
			}else{
				wheel_rot*=0.95;
			}
			
			var incx:Number = Math.sin(wheel_rot * to_rad)*car_speed;
			var n_rot:Number = incx / car_length * 180 / Math.PI;
			car_rot += n_rot;
			car_loader.setRotation(0, car_rot-90, 0);
			
			var incy:Number = Math.cos(wheel_rot * to_rad)*car_speed;
			
			car_loader.x += Math.sin(car_rot*to_rad)*incy;
			car_loader.z += Math.cos(car_rot*to_rad)*incy;
			
			move_wheel();
			
			set_camera(0.25);
		}
		
		private function set_camera(speed:Number=1, ang:Number=0):void{
			scene.camera.setPosition(car_loader.x - cam_dist*Math.sin((car_rot+ang)*to_rad), 100, car_loader.z - cam_height*Math.cos((car_rot+ang)*to_rad), speed);
			scene.camera.lookAt(car_loader.x + cam_dist*0.6*Math.sin((car_rot+ang)*to_rad), 0, car_loader.z + cam_height*0.6 * Math.cos((car_rot+ang)*to_rad));
		}
		
	}
	
}
